import React from 'react';
import { IconProps, IconTagType } from '@uiw/react-icon';
import { IProps, HTMLButtonProps } from '@uiw/utils';
import './style/index.less';
export type ButtonType = 'primary' | 'success' | 'warning' | 'danger' | 'light' | 'dark' | 'link';
export type ButtonSize = 'large' | 'default' | 'small';
export interface ButtonProps extends IProps, Omit<HTMLButtonProps, 'size'> {
    basic?: boolean;
    disabled?: boolean;
    active?: boolean;
    loading?: boolean;
    block?: boolean;
    icon?: IconProps<IconTagType>['type'];
    type?: ButtonType;
    size?: ButtonSize;
    htmlType?: 'button' | 'submit' | 'reset';
    onClick?: (e: React.MouseEvent<HTMLButtonElement> & MouseEvent) => void;
}
declare const _default: React.ForwardRefExoticComponent<Omit<ButtonProps, "ref"> & React.RefAttributes<HTMLButtonElement>>;
export default _default;
